rm(list=ls(all=TRUE))  # clean up left overs from previous run, though shouldn't need to.
if (.Platform$OS.type=="windows") home="/users/radivot" else home="/home/radivot"
#source(paste(home,"/start.r",sep=""))  # define host="machineName" in this file
setwd(home)  # place where models and results will go
if (0) library(ccems) else { # if 0 source in the package 
#  pkgNms=dir(paste(home,"/case/active/ccems/ccems/R",sep=""),full.names=TRUE)
#  for (i in pkgNms) source(i)  # source in all of the R files of the package
  RNR=read.table(file=paste(home,"/case/active/rnr/datasets/RNR.txt",sep=""),header=TRUE)
}
#d=subset(RNR,(year==2002)&(fg==7)&(C>0)&(v>0)&(X<3200),select=c(R,r,C,X,v,year))
d=subset(RNR,(year==2002)&(fg==7)&(C>0)&(v>0),select=c(R,r,C,X,v,year))
d=transform(d,k=v)
names(d)[c(1,4)]=c("RT","XT")
dim(d)
d=d[order(d$XT),]
options(stringsAsFactors = FALSE)
library(PolynomF)
library(snow)
library(DEoptim)
library(rgenoud)  
library(numDeriv)
#library(genalg)  
source(paste(home,"/case/active/ccems/ccems/inst/papers/RXC/commonRXC.R",sep=""))
G=initG(d)
rm(list=c("RNR","d"))
ls()
t0 = Sys.time();      
G=runClust(G,method="optim")
G=lapply(G,mkpdk)
#G=lapply(G,fitModel,method="optim")
class=sapply(G,function(x) x$class)
SSE=sapply(G,function(x) x$SSE$final)
ID=sapply(G,function(x) x$id)
#done=ID[SSE<=3*min(SSE)]
done=ID[(SSE<=4*min(SSE))&((class=="T2")|(class=="T3"))]
GT=G[done]
for (i in done) GT[[i]]$params[,"initial"]=GT[[i]]$params[,"final"]
GT=runClust(GT,method="optim")  # extra run to get extra convergence and Test stability (in the box)
G[done]=GT[done]
for (i in done) { # initially, all done are leads for the next round
  G[[i]]$done=TRUE
  G[[i]]$lead=TRUE
}
deck=setdiff(ID,done)
for (i in deck) { # all in deck are always neither done nor a lead
  G[[i]]$done=FALSE
  G[[i]]$lead=FALSE
}
save(G,file=paste(home,"/results/G0.RData",sep=""))
difftime(Sys.time(),t0,units="mins")
