rm(list=ls(all=TRUE))  # clean up left overs from previous run, though shouldn't need to.
if (.Platform$OS.type=="windows") home="/users/radivot" else home="/home/radivot"
#source(paste(home,"/start.r",sep=""))  # define host="machineName" in this file
setwd(home)  # place where models and results will go

library(PolynomF)
library(snow)
library(DEoptim)
library(rgenoud)  
library(numDeriv)
source(paste(home,"/case/active/ccems/ccems/inst/papers/RXC/commonRXC.R",sep=""))
load(paste(home,"/results/G1.RData",sep=""))
SSE=sapply(G,function(x) x$SSE$final)
ID=sapply(G,function(x) x$id)
done=ID[SSE<=3*min(SSE)] 
deck=ID[SSE>3*min(SSE)] 


SSE1=sapply(GN,function(x) x$SSE$final)
ID1=sapply(GN,function(x) x$id)
(mins=tapply(SSE1,ID1,min))
nG=GN[nms<-names(mins)]  # should take first occurence of index
for (i in nms) {
  if (nG[[i]]$SSE$final > mins[i]) {
    nG[i] = GN[which((SSE1==mins[i])&(ID1==i))[1]]
  } 
}
G[nms]=nG[nms]
SSE1=sapply(nG,function(x) x$SSE$final)
ID1=sapply(nG,function(x) x$id)
done1=ID1[SSE1<=3*min(SSE)] 
deck1=ID1[SSE1>3*min(SSE)] 

leads=done1
length(leads)
done=union(done,done1);
deck=setdiff(deck,deck1)
for (i in done) G[[i]]$done = TRUE
for (i in deck) G[[i]]$done = FALSE
cat("Number of leads = ",length(leads),"Number left in deck = ",length(deck),"\n")
GN=NULL
for (i in leads) {
  draw=getNeighbors(i,deck)
  GN=c(GN,setGICs(G,draw,i))
}

#mkGtab(GN)
cat("The number of models fitted in this round is ",length(GN),"\n")
t0 = Sys.time();      
GN=runClust(GN,method="optim")
#GN=lapply(GN,fitModel,method="optim")
save(G,GN,file=paste(home,"/results/G2.RData",sep=""))
difftime(Sys.time(),t0,units="mins")
