rm(list=ls(all=TRUE))  # clean up left overs from previous run, though shouldn't need to.
# This code is meant to be run on a ROCKS 5.1 cluster
if (.Platform$OS.type=="windows") home="/users/radivot" else home="/home/radivot"
library(PolynomF)
library(snow)
library(DEoptim)
library(rgenoud)  
library(genalg)  
library(numDeriv)

source(paste(home,"/case/active/ccems/ccems/inst/papers/RXC/commonRXC.R",sep=""))
load(paste(home,"/case/active/rnr/RXC/results/G0.RData",sep=""))
G=sortG(G)
tst=G[[20]]
plotg(tst,kill=T)

tst=getEk(tst,init=T)
tst$params[1:3,"opt"] = TRUE

#tst$params["k0","opt"] = FALSE
#tst$params["K0","opt"] = FALSE
#tst$params["K1","opt"] = FALSE
#tst$params["K2","opt"] = FALSE
t0=Sys.time()
bestOptim=fitModel(tst)
difftime(Sys.time(),t0,units="mins")
plotg(bestOptim)
bestOptim
#  I=4,13,22 SSE =0.0021
#tst$params["k0","opt"] = FALSE
#tst$params["K0","opt"] = FALSE
#tst$params["K1","opt"] = FALSE
#tst$params["K2","opt"] = FALSE
#t0=Sys.time()
#bestGenoud=fitModel(tst,method="genoud")
#difftime(Sys.time(),t0,units="mins")
#plotg(bestGenoud)


#tst$params["k0","opt"] = FALSE
#tst$params["K0","opt"] = FALSE
#tst$params["K1","opt"] = FALSE
#tst$params["K2","opt"] = FALSE
#t0=Sys.time()
#bestDE=fitModel(tst,method="DE")
#difftime(Sys.time(),t0,units="mins")
#plotg(bestDE)
#bestDE



