getE<-function(g,init=FALSE){ 
  library(PolynomF)
  if (sum(g$params[,"constr"]!="none")>0) {
    bound=row.names(g$params)[g$params[,"constr"]!="none"]  # bound = follower, free = leader
    free=g$params[bound,"constr"] # these are the free params to which the bound ones are bound
    g$params[bound,"final"]=g$params[free,"final"]
  }
  Pframe=as.data.frame(t(g$params[,"final",drop=F]))
  N=g$nData=dim(g$dk)[1]
  attach(Pframe)
  attach(g$dk)
  for (j in 1:N){
    X=XT[j]
    Rpoly = c(-p*RT[j], 1, 2*(1/K0 + (X/K1)^i1/K1),0,0,0,6*( (X/K2)^i2/K2^5 + (X/K3)^i3/K3^5 ))  
    Rpoly = as.polynom(Rpoly)
    e=try(rts <- solve(Rpoly))
    if (class(e)=="try-error") print("Error in root solver")
    R <- Re(rts[(Mod(Im(rts)) == 0) & (Re(rts) >= 0)])
    Z0=R^2/K0 
    Z1=R^2*X^i1/K1^(i1+1)
    Z2=R^6*X^i2/K2^(i2+5)
    Z3=R^6*X^i3/K3^(i3+5)
    RQ=R+(1-p)*RT[j]+2*Z0+2*Z1+6*Z2+6*Z3
    if (length(R)==1) {
      g$dk$RQ[j]=RQ
      g$dk$Ek[j]=(2*k0*Z0+2*k1*Z1+6*k2*Z2+6*k3*Z3)/RT[j]
      g$dk$R[j]=R
    } else {print("roots length NOT 1"); 
      cat("RQ = ",RQ,"R = ",R,"k0 = ",k0,"K0 = ",K0,"K1 = ",K1,"K2 = ",K2,"K3 = ",K3,"\n")
      cat("rts = ",rts,"\n")
      g$dk$Ek[j]=1}
    if (abs(RT[j]-RQ) > 0.01) {
      print("RT quality control check failed!")
      cat("RQ = ",RQ,"R = ",R,"k0 = ",k0,"K0 = ",K0,"K1 = ",K1,"K2 = ",K2,"K3 = ",K3,"\n")
      g$dk$Ek[j]=1  # big enough to penalize against movement into unstable param values
    }
  }
  detach(g$dk)
  SSEk=sum( ( (g$dk$Ek-g$dk$k)/mean(range(g$dk$Ek)) )^2)
  
  attach(g$dm)
  for (j in 1:N){
    X=XT[j]
    Rpoly = c(-p*RT[j], 1, 2*(1/K0 + (X/K1)^i1/K1),0,0,0,6*( (X/K2)^i2/K2^5 + (X/K3)^i3/K3^5 ))  
    Rpoly = as.polynom(Rpoly)
    e=try(rts <- solve(Rpoly))
    if (class(e)=="try-error") print("Error in root solver")
    R <- Re(rts[(Mod(Im(rts)) == 0) & (Re(rts) >= 0)])
    Z0=R^2/K0 
    Z1=R^2*X^i1/K1^(i1+1)
    Z2=R^6*X^i2/K2^(i2+5)
    Z3=R^6*X^i3/K3^(i3+5)
    RQ=R+(1-p)*RT[j]+2*Z0+2*Z1+6*Z2+6*Z3
    if (length(R)==1) {
      g$dm$RQ[j]=RQ
      g$dm$Em[j]=90*(R+(1-p)*RT[j]+4*(Z0+Z1)+36*(Z2+Z3))/RT[j]
      g$dm$R[j]=R
    } else {print("roots length NOT 1"); 
      cat("RQ = ",RQ,"R = ",R,"K0 = ",K0,"K1 = ",K1,"K2 = ",K2,"K3 = ",K3,"\n")
      cat("rts = ",rts,"\n")
      g$dm$Em[j]=1}
    if (abs(RT[j]-RQ) > 0.01) {
      print("RT quality control check failed!")
      cat("RQ = ",RQ,"R = ",R,"K0 = ",K0,"K1 = ",K1,"K2 = ",K2,"K3 = ",K3,"\n")
      g$dm$Em[j]=1  # big enough to penalize against movement into unstable param values
    }
  }
  detach(g$dm)
  SSEm=sum( ( (g$dm$Em-g$dm$m)/mean(range(g$dm$Em)) )^2)
  
  detach(Pframe)
  SSE=SSEk+SSEm
  P=sum(g$params[,"opt"]) + 1 # include the variance
  aic=N*log(SSE/N)+2*P + 2*P*(P+1)/(N-P-1) + N*log(2*pi) + N
  if (P>=N-1) aic=Inf
  if (init) {
    g$SSE$initial=SSE 
    g$AIC$initial = aic
    g$params[,"initial"] = g$params[,"final"]
  } 
  g$SSE$final=SSE 
  g$AIC$final =  aic
  g
}


getEm<-function(g,init=FALSE){ 
  library(PolynomF)
  if (sum(g$params[,"constr"]!="none")>0) {
    bound=row.names(g$params)[g$params[,"constr"]!="none"]  # bound = follower, free = leader
    free=g$params[bound,"constr"] # these are the free params to which the bound ones are bound
    g$params[bound,"final"]=g$params[free,"final"]
  }
  Pframe=as.data.frame(t(g$params[,"final",drop=F]))
  N=g$nData=dim(g$dm)[1]
  attach(Pframe)
  attach(g$dm)
  for (j in 1:N){
    X=XT[j]
    Rpoly = c(-p*RT[j], 1, 2*(1/K0 + (X/K1)^i1/K1),0,0,0,6*( (X/K2)^i2/K2^5 + (X/K3)^i3/K3^5 ))  
    Rpoly = as.polynom(Rpoly)
    e=try(rts <- solve(Rpoly))
    if (class(e)=="try-error") print("Error in root solver")
    R <- Re(rts[(Mod(Im(rts)) == 0) & (Re(rts) >= 0)])
    Z0=R^2/K0 
    Z1=R^2*X^i1/K1^(i1+1)
    Z2=R^6*X^i2/K2^(i2+5)
    Z3=R^6*X^i3/K3^(i3+5)
    RQ=R+(1-p)*RT[j]+2*Z0+2*Z1+6*Z2+6*Z3
    if (length(R)==1) {
      g$dm$RQ[j]=RQ
      g$dm$Em[j]=90*(R+(1-p)*RT[j]+4*(Z0+Z1)+36*(Z2+Z3))/RT[j]
      g$dm$R[j]=R
    } else {print("roots length NOT 1"); 
      cat("RQ = ",RQ,"R = ",R,"K0 = ",K0,"K1 = ",K1,"K2 = ",K2,"K3 = ",K3,"\n")
      cat("rts = ",rts,"\n")
      g$dm$Em[j]=1}
#    cat("RQ = ",g$d$RQ[j],"\n")
    if (abs(RT[j]-RQ) > 0.01) {
      print("RT quality control check failed!")
      cat("RQ = ",RQ,"R = ",R,"K0 = ",K0,"K1 = ",K1,"K2 = ",K2,"K3 = ",K3,"\n")
      g$dm$Em[j]=1  # big enough to penalize against movement into unstable param values
    }
  }
  detach(Pframe)
  detach(g$dm)
  g$MSSE=sum((g$dm$Em-g$dm$m)^2) 
  g
}


getEk<-function(g,init=FALSE){ 
  library(PolynomF)
  if (sum(g$params[,"constr"]!="none")>0) {
    bound=row.names(g$params)[g$params[,"constr"]!="none"]  # bound = follower, free = leader
    free=g$params[bound,"constr"] # these are the free params to which the bound ones are bound
    g$params[bound,"final"]=g$params[free,"final"]
  }
  Pframe=as.data.frame(t(g$params[,"final",drop=F]))
  N=g$nData=dim(g$dk)[1]
  attach(Pframe)
  attach(g$dk)
  for (j in 1:N){
    X=XT[j]
#    Rpoly = c(-RT[j], 1, 2*(1/K0 + X^i1/K1^(i1+1)),0,0,0,6*(X^i2/K2^(i2+5) + X^i3/K3^(i3+5)))  
    Rpoly = c(-p*RT[j], 1, 2*(1/K0 + (X/K1)^i1/K1),0,0,0,6*( (X/K2)^i2/K2^5 + (X/K3)^i3/K3^5 ))  
#    Rpoly = c(-RT[j], 1, 2*(1/K0 + (X/K1)^i1/K1),0,0,0,6*( (X/K2)^i2/K2^5 + (X/K3)^i3/K3^5 ))  
    Rpoly = as.polynom(Rpoly)
    e=try(rts <- solve(Rpoly))
    if (class(e)=="try-error") print("Error in root solver")
    R <- Re(rts[(Mod(Im(rts)) == 0) & (Re(rts) >= 0)])
    Z0=R^2/K0 
    Z1=R^2*X^i1/K1^(i1+1)
#    Z1=(R*X)^2*(X/K1)^(i1-2)/K1^3  # trying to get some small*big annihilation before powering up
    Z2=R^6*X^i2/K2^(i2+5)
#    Z2=(R*X)^6*(X/K2)^(i2-6)/K2^11
    Z3=R^6*X^i3/K3^(i3+5)
#    Z3=(R*X)^6*(X/K3)^(i3-6)/K3^11
#    RQ=R+2*Z0+2*Z1+6*Z2+6*Z3
    RQ=R+(1-p)*RT[j]+2*Z0+2*Z1+6*Z2+6*Z3
    if (length(R)==1) {
      g$dk$RQ[j]=RQ
      g$dk$Ek[j]=(2*k0*Z0+2*k1*Z1+6*k2*Z2+6*k3*Z3)/RT[j]
      g$dk$R[j]=R
    } else {print("roots length NOT 1"); 
      cat("RQ = ",RQ,"R = ",R,"k0 = ",k0,"K0 = ",K0,"K1 = ",K1,"K2 = ",K2,"K3 = ",K3,"\n")
      cat("rts = ",rts,"\n")
      g$dk$Ek[j]=1}
#    cat("RQ = ",g$d$RQ[j],"\n")
    if (abs(RT[j]-RQ) > 0.01) {
      print("RT quality control check failed!")
      cat("RQ = ",RQ,"R = ",R,"k0 = ",k0,"K0 = ",K0,"K1 = ",K1,"K2 = ",K2,"K3 = ",K3,"\n")
      g$dk$Ek[j]=1  # big enough to penalize against movement into unstable param values
    }
  }
  detach(Pframe)
  detach(g$dk)
  SSE=sum((g$dk$Ek-g$dk$k)^2)
  P=sum(g$params[,"opt"]) + 1 # include the variance
  aic=N*log(SSE/N)+2*P + 2*P*(P+1)/(N-P-1) + N*log(2*pi) + N
  if (P>=N-1) aic=Inf
  if (init) {
    g$SSE$initial=SSE 
    g$AIC$initial = aic
    g$params[,"initial"] = g$params[,"final"]
  } 
  dE=diff(g$dk$Ek)
  dX=diff(g$dk$XT)
#  print(dX)
  dEdX=dE/dX
#  print(dEdX)
  g$trend="T"# tritonic
  if (all(dEdX>0)) g$trend="M" # monotonic
  xm=(g$dk$XT[1:(N-1)]+g$dk$XT[2:N])/2
  ddE<-diff(dEdX)/diff(xm)
  ddEL<-diff(ddE>0)
  g$changes=sum(abs(ddEL))
  g$class=paste(g$trend,g$changes,sep="")
  g$SSE$final=SSE 
  g$AIC$final =  aic
  g
}

###  end getEk

fitModel <- function(g,method="optim") {
  
  fopt <- function(pars,model) {
    pars=exp(pars)
    spt=which(names(pars)=="p")
    if (length(spt)==1) pars[spt]=pars[spt]/(1+pars[spt])
    model$params[names(pars),"final"]=pars  
    model=getEk(model)
#    model=getE(model)
    return(model$SSE$final)   
  }
  
  p0=t(g$params[g$params[,"opt"],"initial",drop=F])
  p0=unlist(as.data.frame(p0))
  p0=sapply(p0,log)
  g$optNames<-names(p0)
  spt=which(names(p0)=="p")
#      print(spt)
  if (length(spt)==1) p0[spt] = log(.9/(1-.9)) # if optimized assume it starts at 0.9 instead of 1 to avoid Inf
  
  print(p0)
  if ((g$nOptParams<-n<-length(p0))>0) { 
    if (method=="optim"){
      print("Method is optim")
      if (g$nOptParams>1) opt<-optim(p0,fopt,hessian=TRUE,model=g,control=list(trace=F,maxit=5000)) else
        opt<-optim(p0,fopt,method="BFGS",hessian=TRUE,model=g,control=list(trace=F));       
      opar<-opt$par
      Hess=opt$hessian
      value=opt$value
      print(value)
      print(fopt(opar,g))
    } else if (method=="genoud") {
      print("Method is genoud")
      opt<-genoud(fopt,nvars=g$nOptParams,model=g,starting.values=p0,hessian=TRUE)
      opar<-opt$par
      names(opar)<-g$optNames
      Hess=opt$hessian
      value=opt$value
      print(opt)
    } else { #if (method=="DE"){ 
      print("Method is DE")
#      pmin=rep(-3,n)
#      pmax=rep(9,n)
      pmin=c(0,0,0,-2,0,0,0,0)  # assuming this many parameters of interest
      pmax=c(3,3,3,0,9,9,9,9)
      print(pmin)
      print(pmax)
      opt=DEoptim(fopt,pmin, pmax,model=g,control=DEoptim.control(itermax = 500)) 
      opar<-opt$optim$bestmem
      names(opar)<-g$optNames
      value=opt$optim$bestval
      Hess=hessian(fopt,opar,g=g)
    }
    opar=exp(opar)  
    if (length(spt)==1) {
      opar[spt]=opar[spt]/(1+opar[spt])
    }
    g$params[g$optNames,"final"]=opar  
    g$Hess=Hess; 
    sg<-sqrt(value/(g$nData-g$nOptParams))
    if (abs(det(Hess))>1e-8) 
    {sig=sg*sqrt(diag(solve(Hess/2)))
      upper=signif(opar+1.96*sig,3)
      lower=signif(opar-1.96*sig,3)
      CI=cbind(lower,upper)
      CI=exp(CI); 
      if (length(spt)==1) 
        CI[spt,]=CI[spt,]/(1+CI[spt,])
      g$CI=CI; 
      g$hess=TRUE} else
    {g$hess=FALSE} 
  } else {print("nothing to optimize");  g$params[,"final"]=g$params[,"initial"] }
  g=getEk(g) # give g the latest expected values
  if (g$SSE$final< g$best$SSE) {
    g$best$SSE=g$SSE$final
    g$best$params=g$params
  }   
#  print(g)
  g
}
# end fitModel


runClust<-function(G,method="optim"){
  bigNms=c("localhost")
  rackLen=c(12,12)
  for (rack in 0:1) for (node in 0:rackLen[rack+1])  bigNms=c(bigNms,paste("compute",rack,node,sep="-"))
  big=rep(4,length(bigNms))
  names(big)<-bigNms
  (cpusPerHost=big)
  if (.Platform$OS.type=="windows") home="/users/radivot" else home="/home/radivot"
  source(paste(home,"/start.r",sep=""))  # define host="machineName" in this file
  if (host=="tk1") cpusPerHost=cpusPerHost[1]
  if (host=="rnrClust") cpusPerHost=cpusPerHost[1:5]
#if (host=="dck") cpusPerHost=big
  if (host=="dNTP") cpusPerHost=c("localhost" = 3)
  if (host=="tk2") cpusPerHost=cpusPerHost[c(1:8)]
  cpusPerHost
  cpus=sum(cpusPerHost)
  hosts=names(cpusPerHost)
  print(host)
  print(cpusPerHost)
  strn=rep(hosts,times=cpusPerHost)
  setDefaultClusterOptions(outfile="/tmp/debugR.t")
  cl <- makeCluster(strn, type="SOCK", verbose=TRUE) # this one can work either way
#  print(clusterCall(cl, function() getwd()))
#  print(clusterCall(cl, function() Sys.info()[c("nodename","machine")]))
  clusterEvalQ(cl, require(PolynomF))
  clusterEvalQ(cl, require(odesolve))
  clusterEvalQ(cl, require(rgenoud))
  clusterEvalQ(cl, require(numDeriv))
  clusterEvalQ(cl, require(DEoptim))
  clusterExport(cl,ls(.GlobalEnv))
  G=clusterApplyLB(cl,G,fitModel,method="optim")
  stopCluster(cl)
  names(G)<-sapply(G,function(x) x$id)
  G
} 



#initG<-function(dk,dm) {
initG<-function(dk) {
  g=NULL
  g$dk=dk
#  g$dm=dm
  cnt=0
  G=NULL
  for (j1 in 1:5) 
    for (j2 in (3*j1+1):17) 
      for (j3 in (j2+1):18){
        cnt=cnt+1
#      cat("count is ",cnt,"\n")                                                          # break
        #      s=c(i1=j1,i2=j2,i3=j3,k0=0.29,k1=0.29,k2=0.0,k3=0.29,K0=3.3,K1=6.7,K2=10,K3=100) # 1 129   K3=200 => 67; K3 = 60 => 136; 20=> error 
#      s=c(i1=j1,i2=j2,i3=j3,k0=0.29,k1=0.29,k2=0.0,k3=0.29,K0=3.5,K1=10,K2=20,K3=60)  # 2  118
#      s=c(i1=j1,i2=j2,i3=j3,k0=0.29,k1=0.29,k2=0.0,k3=0.29,K0=3.5,K1=13,K2=15,K3=60)  # 3  115
#        s=c(i1=j1,i2=j2,i3=j3,k0=0.3,k1=0.3,k2=0.0,k3=0.3,K0=3.3,K1=6.7,K2=10,K3=100) # 
#        s=c(i1=j1,i2=j2,i3=j3,k0=0.3,k1=0.3,k2=0.0,k3=0.3,K0=3.45,K1=6.8,K2=24.5,K3=108) #  T2 medians 
#        s=c(i1=j1,i2=j2,i3=j3,k0=0.33,k1=0.33,k2=0.0,k3=0.33,K0=3,K1=13.6,K2=24,K3=72,p=0.9) # overall medians
        s=c(i1=j1,i2=j2,i3=j3,k0=0.3,k1=0.3,k2=0.0,k3=0.3,K0=3,K1=13.6,K2=24,K3=72,p=1.0) # overall medians
#      2.11.15 5 0.00799 -40.8 2.00  11.00 15.00 0.27  0.27  0.00  0.27  3.17  13.29 34.08 70.13 # typical i1, i2, i3 best fit
#       s=c(i1=j1,i2=j2,i3=j3,k0=0.29,k1=0.29,k2=0.0,k3=0.29,K0=3.5,K1=20,K2=15,K3=60)  # worse, breakpoint at 87
#       s=c(i1=j1,i2=j2,i3=j3,k0=0.29,k1=0.29,k2=0.0,k3=0.29,K0=3.5,K1=15,K2=15,K3=60)  # this caused an error
        g$params=data.frame(initial=s,final=s,opt=TRUE,constr="none")
        g$params[c(1:3,4:8,12),"opt"]=FALSE
#        g$params[c(5,7),"constr"]="k0"
        g$id=paste(j1,j2,j3,sep=".")
        g=getEk(g,init=TRUE)
        g$best$params=g$params
        g$best$SSE=g$SSE$final
        G[[cnt]]=g
      }
  names(G)<-sapply(G,function(x) x$id)
  cat("Total model space count = ",cnt,"\n")                                                          # break
  G
}


mkG0<-function(r=NULL) { # r=5
  if (.Platform$OS.type=="windows") home="/users/radivot" else home="/home/radivot"
#source(paste(home,"/start.r",sep=""))  # define host="machineName" in this file
  setwd(home)  # place where models and results will go
  if (0) library(ccems) else { # if 0 source in the package 
#  pkgNms=dir(paste(home,"/case/active/ccems/ccems/R",sep=""),full.names=TRUE)
#  for (i in pkgNms) source(i)  # source in all of the R files of the package
    RNR=read.table(file=paste(home,"/case/active/rnr/datasets/RNR.txt",sep=""),header=TRUE)
  }
#d=subset(RNR,(year==2002)&(fg==7)&(C>0)&(v>0)&(X<3200),select=c(R,r,C,X,v,year))
#  dk=subset(RNR,(year==2002)&(fg==7)&(C>0)&(v>0),select=c(R,r,C,X,v,year))
  dk=subset(RNR,(year==2010),select=c(R,r,C,X,v,year))
  dk=transform(dk,k=v)
  names(dk)[c(1,4)]=c("RT","XT")
  dim(dk)
  dk=dk[order(dk$XT),]
#  if (!is.null(r)) dk=dk[-r,]
#  dm=subset(RNR,(year==2002)&(fg==7)&(C>0)&(m>0),select=c(R,r,C,X,m,year))
#  names(dm)[c(1,4)]=c("RT","XT")
#  dim(dm)
#  dm=dm[order(dm$XT),]
#  dk
#  dm
  
  options(stringsAsFactors = FALSE)
  library(PolynomF)
  library(snow)
  library(DEoptim)
  library(rgenoud)  
  library(numDeriv)
#library(genalg)  
#source(paste(home,"/case/active/ccems/ccems/inst/papers/RXC/commonRXC.R",sep=""))
  G=initG(dk,dm)
#  rm(list=c("RNR","dk","dm"))
  rm(list=c("RNR","dk"))
  ls()
#t0 = Sys.time();      
  G=runClust(G,method="optim")
  G=lapply(G,mkpdk)
#G=lapply(G,fitModel,method="optim")
  class=sapply(G,function(x) x$class)
  SSE=sapply(G,function(x) x$SSE$final)
  ID=sapply(G,function(x) x$id)
#done=ID[SSE<=3*min(SSE)]
  done=ID[(SSE<=4*min(SSE))&((class=="T2")|(class=="T3"))]
  GT=G[done]
  for (i in done) GT[[i]]$params[,"initial"]=GT[[i]]$params[,"final"]
  GT=runClust(GT,method="optim")  # extra run to get extra convergence and Test stability (in the box)
  G[done]=GT[done]
  for (i in done) { # initially, all done are leads for the next round
    G[[i]]$done=TRUE
    G[[i]]$lead=TRUE
  }
  deck=setdiff(ID,done)
  for (i in deck) { # all in deck are always neither done nor a lead
    G[[i]]$done=FALSE
    G[[i]]$lead=FALSE
  }
#save(G,file=paste(home,"/results/G0.RData",sep=""))
#difftime(Sys.time(),t0,units="mins")
  G[[1]]$hist=NULL
#G[[1]]$hist[[1]]=c(lenLeads=length(leads),lenDeck=length(deck),lenDone=length(done))
  G
}

mkGN<-function(G,N) {
  if (.Platform$OS.type=="windows") home="/users/radivot" else home="/home/radivot"
  setwd(home)  # place where models and results will go
  library(PolynomF)
  library(snow)
  library(DEoptim)
  library(rgenoud)  
  library(numDeriv)
#  load(paste(home,"/results/G",N-1,".RData",sep=""))
  SSE=sapply(G,function(x) x$SSE$final) # needed near the bottom when getting next leads relative to this minimum
  ID=sapply(G,function(x) x$id)
  leadL=sapply(G,function(x) x$lead)
  doneL=sapply(G,function(x) x$done)
  leads=ID[leadL]
  deck=ID[!doneL]
  done=ID[doneL]
  for (i in done) G[[i]]$lead=FALSE  # those done coming in are no longer leads coming out
  cat("Number of leads = ",length(leads)," Number left in deck = ",length(deck),"  Number done = ",length(done),"\n")
  GN=NULL
  for (i in leads) {
    draw=getNeighbors(i,deck)
    GN=c(GN,setGICs(G,draw,i))
  }
  cat("The number of models fitted in this round is ",length(GN),"\n")
#  t0 = Sys.time();      
  if (length(GN)>0) 
  {GN=runClust(GN,method="optim")
    # clean up and condense
    SSEN=sapply(GN,function(x) x$SSE$final)
    IDN=sapply(GN,function(x) x$id)
    (mins=tapply(SSEN,IDN,min))
    nG=GN[nms<-names(mins)]  # should take first occurence of index
    for (i in nms) {
      if (nG[[i]]$SSE$final > mins[i]) {
        nG[i] = GN[which((SSEN==mins[i])&(IDN==i))[1]]
      } 
    }
    nG=lapply(nG,mkpdk)
    G[nms]=nG[nms]  # update if out of deck also
    SSEn=sapply(nG,function(x) x$SSE$final)
    IDn=sapply(nG,function(x) x$id)
    class=sapply(nG,function(x) x$class)
#  leads=IDn[SSEn<=3*min(SSE)] 
    leads=IDn[(SSEn<=4*min(SSE))&((class=="T2")|(class=="T3"))] 
  }
  done=union(done,leads);
  deck=setdiff(ID,done)
  for (i in done) G[[i]]$done=TRUE
  for (i in leads) G[[i]]$lead=TRUE
  #  save(G,file=paste(home,"/results/G",N,".RData",sep=""))
#  difftime(Sys.time(),t0,units="mins")
  G[[1]]$hist[[N]]=c(lenLeads=length(leads),lenDeck=length(deck),lenDone=length(done))
  G[[1]]$lenLeads=length(leads)
  G
} 


