mkpdk<-function(g){
  pd=data.frame(RT=1.2, XT=c(seq(0,3200,by=20),seq(9900,10100,by=100)))
  pg=g
  pg$dk=pd
  pg=getEk(pg)
  g$pdk=pg$dk
  g$class=pg$class   # set class based on fine X since initial curve up needs finer samples
  g
}

mkpdm<-function(g){
  pd=data.frame(RT=7, XT=seq(0,3400,by=20))
  pg=g
  pg$dm=pd
  pg=getEm(pg)
  g$pdm=pg$dm
  g
}

doneNdeck<-function(G) {
  leadL=sapply(G,function(x) x$lead)
  doneL=sapply(G,function(x) x$done)
  cat("Number of leads = ",sum(leadL)," Number left in deck = ",sum(!doneL),"  Number done = ",sum(doneL),"\n")
}

getNeighbors<-function(best,deck) {
  Ib=sapply(strsplit(best,'\\.'),as.numeric)%*%rep(1,length(deck))
  Id=sapply(strsplit(deck,'\\.'),as.numeric)
  A=abs(Ib-Id)
  A=(A<=1)
  deck[as.logical(apply(A,2,prod))]
}

setGICs<-function(G,draw,best){
  nG=G[draw]
  for (i in draw) nG[[i]]$params[4:11,"initial"]=G[[best]]$params[4:11,"final"]
  nG }

sortG<-function(G,mass=FALSE){ 
  if (!mass) SSE<-sapply(G,function(x) x$SSE$final) else SSE<-sapply(G,function(x) x$MSSE)
  I=order(SSE)
  G[I]
}
