if (.Platform$OS.type=="windows") home="/users/radivot" else home="/home/radivot"
source(paste(home,"/case/active/ccems/ccems/inst/papers/RXC/commonZ1.R",sep=""))
t0 = Sys.time();      
setwd(home)  # place where models and results will go
library(ccems)
#d=subset(RNR,(year==2002)&(fg==7)&(C>0)&(v>0)&(X<3200),select=c(R,r,C,X,v,year))
dk=subset(RNR,(year==2010),select=c(R,r,C,X,v,year))
dk=transform(dk,k=v)
names(dk)[c(1,4)]=c("RT","XT")
dim(dk)
dk=dk[order(dk$XT),]
#dk=dk[1:(dim(dk)[1]-3),]

options(stringsAsFactors = FALSE)
library(PolynomF)
library(snow)
G=initGZMM(dk)
G=runClust(G,Z=3)
G=lapply(G,mkpdkMM)
save(G,file=paste(home,"/results/GZMM.RData",sep=""))
difftime(Sys.time(),t0,units="mins")

